//+------------------------------------------------------------------+
//|                                                       Levels.mq4 |
//+------------------------------------------------------------------+
#property strict
#property indicator_chart_window

enum Bias {
Bullish=2, //Bullish
Bearish=3, //Bearish 
};
input Bias Mybias=2; //My Bias                  
// --there would be no need to input a bias if I came up with a workaround to using a separate indicator which would need to be applied on the chart as well

//void GetBiasConviction(TimePeriod=pertinent Daily/Weekly/Monthly){
//double PivPrefBias = ObjectGetDouble(0,"stPivPrefD10",OBJPROP_PRICE);    //current
//double FPivPrefBias = ObjectGetDouble(0,"stPivPrefFD1",OBJPROP_PRICE);   //future
//Print(PivPrefBias);
//Print(FPivPrefBias);

//if (PivPrefBias>0 && FPivPrefBias>0){MyBias = 21} //Day/Week/Month will be 2,4,6 if Bullish
//if (PivPrefBias<0 && FPivPrefBias<0){MyBias = 31} //...                    3,5,7 if Bearish
//if (PivPrefBias>=0 && FPivPrefBias<=0){MyBias = 22} //
//if (PivPrefBias<=0 && FPivPrefBias>=0){MyBias = 32} //......................first digit......
//if (PivPrefBias>0 && FPivPrefBias>0){MyBias = 41} //
//if (PivPrefBias<0 && FPivPrefBias<0){MyBias = 51} //
//if (PivPrefBias>=0 && FPivPrefBias<=0){MyBias = 42} //........................................
//if (PivPrefBias<=0 && FPivPrefBias>=0){MyBias = 52} //second digit will denote Conviction
//if (PivPrefBias>0 && FPivPrefBias>0){MyBias = 61} //...              1 Aggressive
//if (PivPrefBias<0 && FPivPrefBias<0){MyBias = 71} //
//if (PivPrefBias>=0 && FPivPrefBias<=0){MyBias = 62} //...              2 Conservative
//if (PivPrefBias<=0 && FPivPrefBias>=0){MyBias = 72} //

//use in the start
/*
if(Use_Daily){
 PlotLevels(
 */
 
extern ENUM_TIMEFRAMES  TimePeriod=PERIOD_D1;

int init(){
   ObjectsDeleteAll();
   return(INIT_SUCCEEDED);
   }

int deinit(){
   ObjectsDeleteAll();
   return(0);
   }
//------------------------------------------------------------------------------------------------------------------------|
//every Duration-Direction-Conviction will have its own names array that the PlotLevels function shall cycle through -----|
//------------------------------------------------------------------------------------------------------------------------|
//the level names will have the following naming heurstic/key-------------------------------------------------------------|
//if(Daily) then d; if(Weekly) then w; if(Monthly) then m                                                == first chracter|
//if(Bullish) then 0; if(Bearish) then 1                                                               == second character|
//if(Aggressive) then a; if(Conservative) then c                                                        == third character|
//levels order number (none for Baseline or Anchor)                                                    == fourth character|
//if(Anchor) then K; if(Baseline) then B                                                              ==also, fourth char |
//if(Reversal) then v; if(Retracement) then t; if(Extension) then x                                     ==fifth character |
//--------------------------------------------------------------------------------------------------------------------|||||
int start(){ 
/*
string d0aN[13]={"d0a4v","d0a3v","d0a2v","d0a1v","d0aK","d0a1t","d0a2t","d0a3t","d0aB","d0a1x","d0a2x","d0a3x","d0a4x"};
string d1aN[13]={"d1a4v","d1a3v","d1a2v","d1a1v","d1aK","d1a1t","d1a2t","d1a3t","d1aB","d1a1x","d1a2x","d1a3x","d1a4x"};
string d0cN[13]={"d0c4v","d0c3v","d0c2v","d0c1v","d0cK","d0c1t","d0c2t","d0c3t","d0cB","d0c1x","d0c2x","d0c3x","d0c4x"};
string d1cN[13}={"d1c4v","d1c3v","d1c2v","d1c1v","d1cK","d1c1t","d1c2t","d1c3t","d1cB","d1c1x","d1c2x","d1c3x","d1c4x"};
string w0aN[13]={"w0a4v","w0a3v","w0a2v","w0a1v","w0aK","w0a1t","w0a2t","w0a3t","w0aB","w0a1x","w0a2x","w0a3x","w0a4x"};
string w1aN[13}={"w1a4v","w1a3v","w1a2v","w1a1v","w1aK","w1a1t","w1a2t","w1a3t","w1aB","w1a1x","w1a2x","w1a3x","w1a4x"};
string w0cN[13}={"w0c4v","w0c3v","w0c2v","w0c1v","w0cK","w0c1t","w0c2t","w0c3t","w0cB","w0c1x","w0c2x","w0c3x","w0c4x"};
string w1cN[13}={"w1c4v","w1c3v","w1c2v","w1c1v","w1cK","w1c1t","w1c2t","w1c3t","w1cB","w1c1x","w1c2x","w1c3x","w1c4x"};
string m0aN[13]={"m0a4v","m0a3v","m0a2v","m0a1v","m0aK","m0a1t","m0a2t","m0a3t","m0aB","m0a1x","m0a2x","m0a3x","m0a4x"};
string m1aN[13}={"m1a4v","m1a3v","m1a2v","m1a1v","m1aK","m1a1t","m1a2t","m1a3t","m1aB","m1a1x","m1a2x","m1a3x","m1a4x"};
string m0cN[13}={"m0c4v","m0c3v","m0c2v","m0c1v","m0cK","m0c1t","m0c2t","m0c3t","m0cB","m0c1x","m0c2x","m0c3x","m0c4x"};
string m1cN[13}={"m1c4v","m1c3v","m1c2v","m1c1v","m1cK","m1c1t","m1c2t","m1c3t","m1cB","m1c1x","m1c2x","m1c3x","m1c4x"};
*/
string Bulllvls[13]={"BLRev4","BLRev3","BLRev2","BLRev1","BLAnchor","BLRet3","BLRet2","BLRet1","BLBaseline","BLExt1","BLExt2","BLExt3","BLExt4"}; //Bullish Price levels
string Bearlvls[13]={"BrRev4","BrRev3","BrRev2","BrRev1","BrAnchor","BrRet3","BrRet2","BrRet1","BrBaseline","BrExt1","BrExt2","BrExt3","BrExt4"}; //Bearish Price levels

const double Rlvls[13]={-2,-1.75,-1.5,-1.25,-1,-0.75,-0.5,-0.25,0,0.25,0.5,0.75,1};       //Ratio Levels
//--------------------------------------------------------------------------------------------------------------------|||||
double high, low, close, Time1, Time2, BLwidth, Brwidth;

int ts=14400;
switch(TimePeriod){
   case(43200):ts=2520000;break;   
   case(10080):ts=512000; break;
   case(1440):ts=86480;break;
   case(240):ts=14400;break;
   case(60):ts=3600;break;
   case(30):ts=1800;break;
   case(15):ts=900;break;
   case(5):ts=300;break;
   case(1):ts=60;break;
   }
        Time1 = iTime(NULL, TimePeriod,0);
        Time2 = Time1+ts;                 //this is the presumed end-time of the period, offset
        high  = iHigh(NULL,TimePeriod,1);
        low   = iLow(NULL,TimePeriod,1);
        close = iClose(NULL,TimePeriod,1);
        BLwidth=close-low;
        Brwidth=high-close;

if(Mybias!=3){

//if(Use_Daily){
//GetBiasConviction(Daily){...//...return( PlotLevelsNames[13] = d0aN[13] or d0cN[13] or d1aN[13] or d1cN[13] )
//PlotLevels(PlotLevelNames[13]

//if(Use_Weekly){
//GetBiasConviction(Weekly){...//...return( PlotLevelsNames[13] = w0aN[13] or w0cN[13] or w1aN[13] or w1cN[13] )
//PlotLevels(PlotLevelNames[13]

//if(Use_Monthly){
//GetBiasConviction(Monthly){...//...return( PlotLevelsNames[13] = m0aN[13] or m0cN[13] or m1aN[13] or m1cN[13] )
//PlotLevels(PlotLevelNames[13]


//void PlotLevels(PlotLevelNames
/*
  for(int iObj=ObjectsTotal()-1; iObj >= 0; iObj--){
        string lvlout = ObjectName(iObj);
        if (StringFind(lvlout, "__first two characters of PlotLevelNames[]") != 0)  ObjectDelete(lvlout);}
*/

  for(int iObj=ObjectsTotal()-1; iObj >= 0; iObj--){
        string BLout = ObjectName(iObj);
        if (StringFind(BLout, "Br") == 0)  ObjectDelete(BLout);}
  ObjectDelete("LSB");
        
  ObjectCreate(NULL,"LBB",OBJ_TREND,0,Time1,low,Time2,low);    //LBB stands for Levels Buy Border as is an invalidation level for the EA, same for LSB
  ObjectSetInteger(NULL,"LBB",OBJPROP_COLOR,clrFireBrick);
  ObjectSetInteger(NULL,"LBB",OBJPROP_STYLE,STYLE_SOLID);
  ObjectSetInteger(NULL,"LBB",OBJPROP_WIDTH,3);
  ObjectSetInteger(NULL,"LBB",OBJPROP_SELECTABLE,true);
  ObjectSetInteger(NULL,"LBB",OBJPROP_SELECTED,false);
  ObjectSetInteger(NULL,"LBB",OBJPROP_RAY,false);
  ObjectSetInteger(NULL,"LBB",OBJPROP_HIDDEN,false);
  
  for(int i=0; i<=13; i++){
    double st= close+Rlvls[i]*BLwidth; //st is the starting price
    double ep= high+Rlvls[i]*BLwidth; //ep is the ending price
    ObjectCreate(NULL,Bulllvls[i],OBJ_TREND,0,Time1,st,Time2,ep);
    ObjectSetInteger(NULL,Bulllvls[i],OBJPROP_COLOR,clrDarkGreen);
    ObjectSetInteger(NULL,Bulllvls[i],OBJPROP_STYLE,STYLE_DASH);
    ObjectSetInteger(NULL,Bulllvls[i],OBJPROP_WIDTH,1);
    ObjectSetInteger(NULL,Bulllvls[i],OBJPROP_SELECTABLE,true);
    ObjectSetInteger(NULL,Bulllvls[i],OBJPROP_SELECTED,false);
    ObjectSetInteger(NULL,Bulllvls[i],OBJPROP_RAY,false);
    ObjectSetInteger(NULL,Bulllvls[i],OBJPROP_HIDDEN,false);
    ObjectSetInteger(NULL,"BLAnchor",OBJPROP_WIDTH,3);
    ObjectSetInteger(NULL,"BLBaseline",OBJPROP_WIDTH,3);}
   }
//==================================================================
else{
   for(int iObj=ObjectsTotal()-1; iObj >= 0; iObj--){
        string Brout = ObjectName(iObj);
        if (StringFind(Brout, "BL") == 0)  ObjectDelete(Brout);}   
   ObjectDelete("LBB");
   
   ObjectCreate(NULL,"LSB",OBJ_TREND,0,Time1,high,Time2,high); 
   ObjectSetInteger(NULL,"LSB",OBJPROP_COLOR,clrFireBrick);
   ObjectSetInteger(NULL,"LSB",OBJPROP_STYLE,STYLE_DASH);
   ObjectSetInteger(NULL,"LSB",OBJPROP_WIDTH,3);
   ObjectSetInteger(NULL,"LSB",OBJPROP_SELECTABLE,true);
   ObjectSetInteger(NULL,"LSB",OBJPROP_SELECTED,false);
   ObjectSetInteger(NULL,"LSB",OBJPROP_RAY,false);
   ObjectSetInteger(NULL,"LSB",OBJPROP_HIDDEN,false);
   
   for(int i=0; i<=13; i++){
    double st= close-Rlvls[i]*Brwidth;
    double ep= low-Rlvls[i]*Brwidth;
    ObjectCreate(NULL,Bearlvls[i],OBJ_TREND,0,Time1,st,Time2,ep);
    ObjectSetInteger(NULL,Bearlvls[i],OBJPROP_COLOR,clrDarkBlue);
    ObjectSetInteger(NULL,Bearlvls[i],OBJPROP_STYLE,STYLE_DASH);
    ObjectSetInteger(NULL,Bearlvls[i],OBJPROP_WIDTH,1);
    ObjectSetInteger(NULL,Bearlvls[i],OBJPROP_SELECTABLE,true);
    ObjectSetInteger(NULL,Bearlvls[i],OBJPROP_SELECTED,false);
    ObjectSetInteger(NULL,Bearlvls[i],OBJPROP_RAY,false);
    ObjectSetInteger(NULL,Bearlvls[i],OBJPROP_HIDDEN,false);
    ObjectSetInteger(NULL,"BrAnchor",OBJPROP_WIDTH,3);
    ObjectSetInteger(NULL,"BrBaseline",OBJPROP_WIDTH,3);}
  }return(0);}//closing start()